console.log( "titleL.js loading.." );

//- 関数リスト -	..	
// 1:	dummy		..	
// 2:	titleL.init		..	
// 3:	titleL.start		..	
// 4:	titleL.stop		..	
// 5:	titleL.frame		..	



//関数 1 / 5		..	
function dummy() {
}

titleL = new Object();
titleL.name = "titleL";
//関数 2 / 5		..	
addEventListener( "load", function() {
/*
	初期化他、
	タイトルの文字色アニメと、雪アニメを設定する。
*/

	//初期化
	this.cursorY = 0;
	this.items = [
		"Start",
		"Continue",
	];
	
	//アニメ設定
	var fc = document.getElementById( "frontCanvas" ).getContext( "2d" );
	this.titleColor = [ 255, 255, 128 ];
	this.anms = new Array();
	
		//タイトル色アニメ
		var anm = new Anm( 255, 2000, this, null, function() {
			//this is anm.
			//this.object is titleL.
			var value = ( this.loopCount % 2 ) ? this.nowLen : ( 255 - this.nowLen );
			this.object.titleColor[ 0 ] = value;
			this.object.titleColor[ 1 ] = value;
		} );
		anm.loopFLG = true;
		this.anms.push( anm );
		
		//タイトル雪アニメ
		this.snows = new Array();
		for( var i = 0; i < 40; i++ ) {	//雪の数　だけ生成
			var snow = new Object();
				snow.x = Math.random() * fc.canvas.width;
				snow.y = Math.random() * fc.canvas.height;
				snow.sz = Math.round( 4 - Math.random() * 2 );
				snow.colorRate = [ .7, .8, 1 ][ snow.sz - 2];//サイズ2,3,4　に対する雪の色
				snow.theta = Math.random() * 6.28;
				this.snows.push( snow );
		}
		//雪の１コマ
		var anm = new Anm( fc.canvas.height, 5000, this, null, function() {
			//this is anm.
			//this.object is titleL.
			for( var i = 0; i < this.object.snows.length; i++ ) {
				var snow = this.object.snows[ i ];
					snow.y += snow.sz / 3;	//雪の落ちるスピード
						//check.
						if( snow.y > fc.canvas.height + 8 ) {
							snow.y = -8;
						}
					snow.theta += .025;
			}
		} );
		anm.loopFLG = true;
		this.anms.push( anm );
		
}.bind( titleL ), false );

//関数 5 / 5		..	
titleL.keyExec = function() {
	/*
		タイトル画面のキー入力を処理している。
		
	*/
	//key title
	for( var i = 0; i < keys.length; i++ ) {
		var key = keys[ i ];
			//check.　削除でキータイプ化になる
			keys.splice( i--, 1 );
		
		switch( key ) {
			case 38:
			case 40:
				this.cursorY += ( key == 40 ) - ( key == 38 );
					//check.
					if( this.cursorY < 0 ) this.cursorY = 0;
					if( this.cursorY >= this.items.length ) this.cursorY = this.items.length - 1;
				break;
			case 13:
				currentScene = mapL;
				effect.beforeScene = titleL;
				effect.start();
		}
	}
}
titleL.frame = function( cc ) {
	/*
	タイトル画面のアニメーションの一コマを進めて、
	タイトル画面の各レイヤーを描画している。
	*/
	//animate title
	for( var i = 0; i < this.anms.length; i++ ) {
		var anm = this.anms[ i ];
			anm.frame();
			anm.step();
				//check.
				if( anm.deleteFLG ) {
					this.anms.splice( i--, 1 );
				}
	}
	
	//draw title
	cc.fillStyle = "black";
	cc.fillRect( 0, 0, cc.canvas.width, cc.canvas.height );
	var matrixX = 80;
	var matrixY = 130;
	for( var z = 0; z < 10; z++ )
	switch( z ) {
		case 0:
			//title
			var sz = 48;
			cc.font = sz + "px ''";
			cc.fillStyle = "rgb(" + this.titleColor.join() + ")";
			var str = "Test RPG";
			var m = cc.measureText( str );
			var gx = ( cc.canvas.width - m.width ) / 2;
			var gy = ( cc.canvas.height - sz ) / 2 + sz / 2;
			cc.fillText( str, gx, gy, m.width );
			break;
		case 1:
			//snow
			for( var i = 0; i < this.snows.length; i++ ) {
				var snow = this.snows[ i ];
				cc.beginPath();
				//sinの係数が雪の揺れ
				cc.arc( snow.x + Math.sin( snow.theta ) * 10, snow.y, snow.sz, 0, 6.28, false );
				cc.closePath();
				var c = 255 * snow.colorRate;
				var b = ( 150 + ( 255- 150 ) * snow.colorRate );	//雪の青み
				cc.fillStyle = "rgb(" + c + ","+ c + "," + b + ")";
				cc.fill();
			}
			break;
		case 2:
			//grid matrix
			cc.save();
			cc.translate( matrixX, matrixY );
			for( var c = 0; c < 2; c++ ) {
				var gx = c * 16;
				for( var r = 0; r < this.items.length; r++ ) {
					var gy = r * 16;
					var gw = 16;
					var gh = 16;
					cc.strokeStyle = "rgb(50,50,50)";
				//	cc.strokeRect( gx, gy, gw, gh );
					
					if( c == 1 ) {
						cc.font = "16px''";
						cc.fillStyle = r == this.cursorY ? "yellow" : "white";
						cc.fillText( this.items[ r ], gx, gy + 16 - 3 );
					}
				}
			}
			cc.restore();
			break;
		case 3:
			//cursor
			cc.save();
				cc.translate( matrixX, matrixY + this.cursorY * 16 );
				cc.beginPath();
				cc.moveTo( 0, 0 );
				cc.lineTo( 0, 15 );
				cc.lineTo( 10, 7 );
				cc.closePath();
				cc.fillStyle = "salmon";
				cc.fill();
			cc.restore();
			break;
	}
}
